unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  myBlock, grid;

type

  { TForm1 }

  TForm1 = class(TForm)
    ColorDialog1: TColorDialog;
    l_ResetPosition: TLabel;
    l_touching: TLabel;
    l_changecolor: TLabel;
    Label3: TLabel;
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure bColorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure l_ResetPositionClick(Sender: TObject);
    procedure l_changecolorMouseEnter(Sender: TObject);
    procedure l_changecolorMouseLeave(Sender: TObject);
    procedure l_ResetPositionMouseEnter(Sender: TObject);
    procedure l_ResetPositionMouseLeave(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure setColors;

    procedure Timer1Timer(Sender: TObject);
  private

  public

  end;




var
  Form1: TForm1;


  blockTwo: TBlock;
  gridTwo:TGrid;



implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  blockTwo.Draw(PaintBox1.Canvas);



end;

procedure TForm1.setColors;
begin
  ColorDialog1.Color := blockTwo.Color;
  ColorDialog1.Execute;
  blockTwo.Color := ColorDialog1.Color;
  l_ResetPosition.Color := ColorDialog1.Color;
  l_changecolor.Color := ColorDialog1.Color;
  l_touching.Font.Color := ColorDialog1.Color;
  Invalidate;
end;



procedure TForm1.Timer1Timer(Sender: TObject);
begin
  blockTwo.moveRight(50);
  Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  blockTwo := TBlock.Create(PaintBox1.Canvas);
  blockTwo.setColor := $00D5A060;
  gridTwo := TGrid.Create(Form1.Canvas);

end;

procedure TForm1.FormPaint(Sender: TObject);
begin
   gridTwo.draw_grid(0,0,0,0,Form1.Canvas);
end;

procedure TForm1.l_ResetPositionClick(Sender: TObject);
begin
  blockTwo.resetPosition;
end;

procedure TForm1.l_changecolorMouseEnter(Sender: TObject);
begin
  l_changecolor.color := RGBToColor(Red(blockTwo.Color) - 15,
    Green(blockTwo.Color) - 15, Blue(blockTwo.Color) - 15);

end;

procedure TForm1.l_changecolorMouseLeave(Sender: TObject);
begin
  l_changecolor.Color := blockTwo.Color;
end;

procedure TForm1.l_ResetPositionMouseEnter(Sender: TObject);
begin
  l_ResetPosition.color :=
    RGBToColor(Red(blockTwo.Color) - 15, Green(blockTwo.Color) - 15,
    Blue(blockTwo.Color) - 15);
end;

procedure TForm1.l_ResetPositionMouseLeave(Sender: TObject);
begin
  l_ResetPosition.Color := blockTwo.Color;
end;

procedure TForm1.bColorClick(Sender: TObject);
begin
  setColors;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  blockTwo.mousetouch(X, Y);
  if blockTwo.touched then
    l_touching.Caption := 'it is touching';

end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
begin

  blockTwo.move(X, Y);
  Repaint;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  blockTwo.touched := False;
  l_touching.Caption := 'not touching block';
end;

end.
